diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 4c36e0855..1c68fdc5e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -1,9 +1,7 @@
 package net.minecraft.client.render;
 
-import java.util.List;
-import java.util.Random;
-
 import com.mojang.logging.LogUtils;
+import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.CompareFunc;
@@ -27,14 +25,13 @@ import org.joml.primitives.AABBdc;
 import org.lwjgl.input.Mouse;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.particle.ParticleWaterDrop;
-import net.minecraft.client.render.particle.ParticleSmoke;
 import net.minecraft.client.entity.player.PlayerLocal;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.MouseFilter;
 import net.minecraft.client.input.PlayerInput;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.EntityCameraFirstPerson;
@@ -43,15 +40,17 @@ import net.minecraft.client.render.camera.EntityCameraSleeping;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonFront;
 import net.minecraft.client.render.camera.EntityCameraThirdPersonRear;
 import net.minecraft.client.render.colorizer.Colorizers;
-import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.particle.ParticleSmoke;
+import net.minecraft.client.render.particle.ParticleWaterDrop;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.core.util.debug.Debug;
-import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.debug.Debug;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Time;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
@@ -59,6 +58,9 @@ import net.minecraft.core.world.weather.Weather;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
+import java.util.List;
+import java.util.Random;
+
 public class WorldRenderer {
     private static final Logger LOGGER = LogUtils.getLogger();
     public static final long nsPerSecond = 1_000_000_000L;
@@ -116,7 +118,7 @@ public class WorldRenderer {
 
     private void updateSpeedFov() {
         PlayerLocal player = this.mc.thePlayer;
-        float currentFovModifier = this.mc.gameSettings.fovModification.value ? player.getFovModifier() : 1f;
+        float currentFovModifier = GameSettings.FOV_MODIFICATION.value ? player.getFovModifier() : 1f;
         this.fovModOld = this.fovMod;
         this.fovMod += (currentFovModifier - this.fovMod) * 0.5f;
     }
@@ -208,7 +210,7 @@ public class WorldRenderer {
             fov = (int) (this.mc.activeCamera.getFov() * 100 + 30);
             fov *= org.joml.Math.lerp(this.fovModOld, this.fovMod, partialTick);
         }
-        if (this.mc.gameSettings.fovModification.value && CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
+        if (GameSettings.FOV_MODIFICATION.value && CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
             fov = fov - 10;
         }
         if (entityliving != null && entityliving.getHealth() <= 0) {
@@ -271,11 +273,11 @@ public class WorldRenderer {
                         this.mc.activeCamera.getX(partialTick), this.mc.activeCamera.getY(partialTick), this.mc.activeCamera.getZ(partialTick), this.mc.activeCamera.getYRot(partialTick), this.mc.activeCamera.getXRot(partialTick)
                     );
                 }
-            } else if (this.mc.gameSettings.thirdPersonView.value == 0 && !(this.mc.activeCamera instanceof EntityCameraFirstPerson)) {
+            } else if (GameSettings.THIRD_PERSON_VIEW.value == 0 && !(this.mc.activeCamera instanceof EntityCameraFirstPerson)) {
                 this.mc.activeCamera = new EntityCameraFirstPerson(this.mc, mob);
-            } else if (this.mc.gameSettings.thirdPersonView.value == 1 && !(this.mc.activeCamera instanceof EntityCameraThirdPersonRear)) {
+            } else if (GameSettings.THIRD_PERSON_VIEW.value == 1 && !(this.mc.activeCamera instanceof EntityCameraThirdPersonRear)) {
                 this.mc.activeCamera = new EntityCameraThirdPersonRear(this.mc, mob);
-            } else if (this.mc.gameSettings.thirdPersonView.value == 2 && !(this.mc.activeCamera instanceof EntityCameraThirdPersonFront)) {
+            } else if (GameSettings.THIRD_PERSON_VIEW.value == 2 && !(this.mc.activeCamera instanceof EntityCameraThirdPersonFront)) {
                 this.mc.activeCamera = new EntityCameraThirdPersonFront(this.mc, mob);
             }
         }
@@ -285,7 +287,7 @@ public class WorldRenderer {
     public @NotNull Matrix4f orientCamera(@NotNull Matrix4f matrix, float partialTick) {
         setupCamera(partialTick);
 
-        if (!(this.mc.currentScreen instanceof ScreenPhotoMode) && !this.mc.gameSettings.lockCamera.value) {
+        if (!(this.mc.currentScreen instanceof ScreenPhotoMode) && !GameSettings.LOCK_CAMERA.value) {
             matrix.rotateX(org.joml.Math.toRadians((float) this.mc.activeCamera.getXRot(partialTick)));
             matrix.rotateY(org.joml.Math.toRadians((float) (this.mc.activeCamera.getYRot(partialTick) + 180F)));
         }
@@ -299,7 +301,7 @@ public class WorldRenderer {
 
     public @NotNull Matrix4f getProjectionMatrix(@NotNull Matrix4f matrix, float partialTick) {
         matrix.identity();
-        this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
+        this.farPlaneDistance = GameSettings.RENDER_DISTANCE.value * 16;
         float fov = getFOVModifier(partialTick, true);
         if (this.zooming) {
             fov = getZoomedFOV(fov, partialTick);
@@ -320,17 +322,18 @@ public class WorldRenderer {
     public @NotNull Matrix4f getViewMatrix(@NotNull Matrix4f matrix, float partialTick) {
         matrix.identity();
         hurtCameraEffect(matrix, partialTick);
-        if (this.mc.gameSettings.viewBobbing.value && !(this.mc.currentScreen instanceof ScreenPhotoMode)) {
+        if (GameSettings.VIEW_BOBBING.value && !(this.mc.currentScreen instanceof ScreenPhotoMode)) {
             setupViewBobbing(matrix, partialTick, false);
         }
 
-        final float portalIntensity = this.mc.gameSettings.screenMotionEffects.value ? MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTick) : 0f;
+        final float portalIntensity = GameSettings.SCREEN_MOTION_EFFECTS.value ? MathHelper.lerp(this.mc.thePlayer.prevTimeInPortal, this.mc.thePlayer.timeInPortal, partialTick) : 0f;
         if (portalIntensity > 0.0F) {
             float f3 = 5F / (portalIntensity * portalIntensity + 5F) - portalIntensity * 0.04F;
             f3 *= f3;
-            matrix.rotate(org.joml.Math.toRadians(((float) this.rendererUpdateCount + partialTick) * 20F), 0.0F, 1.0F, 1.0F);
+            float rotation = org.joml.Math.toRadians(((float) this.rendererUpdateCount + partialTick) * 20F);
+            matrix.rotate(rotation, 0.0F, 0.7071f, 0.7071f);
             matrix.scale(1.0F / f3, 1.0F, 1.0F);
-            matrix.rotate(org.joml.Math.toRadians(-((float) this.rendererUpdateCount + partialTick) * 20F), 0.0F, 1.0F, 1.0F);
+            matrix.rotate(-rotation, 0.0F, 0.7071f, 0.7071f);
         }
 
         orientCamera(matrix, partialTick);
@@ -340,7 +343,7 @@ public class WorldRenderer {
     private void renderHand(float partialTick) {
         Matrix4f projMat = GLRenderer.projectionM4f();
         projMat.identity();
-        this.farPlaneDistance = this.mc.gameSettings.renderDistance.value * 16;
+        this.farPlaneDistance = GameSettings.RENDER_DISTANCE.value * 16;
         float fov = getFOVModifier(partialTick, false);
         if (this.zooming) {
             fov = getZoomedFOV(fov, partialTick);
@@ -360,10 +363,10 @@ public class WorldRenderer {
 
         GLRenderer.pushFrame();
         hurtCameraEffect(viewMat, partialTick);
-        if (this.mc.gameSettings.viewBobbing.value) {
+        if (GameSettings.VIEW_BOBBING.value) {
             setupViewBobbing(viewMat, partialTick, true);
         }
-        if (this.mc.gameSettings.thirdPersonView.value == 0 && !(this.mc.currentScreen instanceof ScreenPhotoMode) && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping()) && this.mc.gameSettings.immersiveMode.drawHand()) {
+        if (GameSettings.THIRD_PERSON_VIEW.value == 0 && !(this.mc.currentScreen instanceof ScreenPhotoMode) && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping()) && GameSettings.IMMERSIVE_MODE.drawHand()) {
             this.lightmapHelper.enableLightmapRendering();
             if (!this.zooming) this.itemRenderer.renderItemInFirstPerson(partialTick);
             this.lightmapHelper.disableLightmapRendering();
@@ -373,11 +376,11 @@ public class WorldRenderer {
         Debug.change("post");
         this.mc.renderer.endRenderWorld(partialTick);
 
-        if (this.mc.gameSettings.thirdPersonView.value == 0 && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping())) {
+        if (GameSettings.THIRD_PERSON_VIEW.value == 0 && !(!(this.mc.activeCamera instanceof EntityCamera) || ((EntityCamera) this.mc.activeCamera).mob.isPlayerSleeping())) {
             this.itemRenderer.renderOverlays(partialTick);
             hurtCameraEffect(viewMat, partialTick);
         }
-        if (this.mc.gameSettings.viewBobbing.value) {
+        if (GameSettings.VIEW_BOBBING.value) {
             setupViewBobbing(viewMat, partialTick, false);
         }
     }
@@ -408,7 +411,7 @@ public class WorldRenderer {
         this.lightmapHelper.update(partialTick);
         if (this.mc.inGameHasFocus) {
             if (Mouse.isGrabbed()) {
-                float sensitivity = this.mc.gameSettings.mouseSensitivity.value * 0.6F + 0.2F;
+                float sensitivity = GameSettings.MOUSE_SENSITIVITY.value * 0.6F + 0.2F;
                 sensitivity = sensitivity * sensitivity * sensitivity * 8.0f;
                 if (this.zooming) sensitivity *= 0.25f;
 
@@ -418,10 +421,10 @@ public class WorldRenderer {
 //                System.out.printf("%s %s\n", deltaX, deltaY);
 
                 int l = 1;
-                if (this.mc.gameSettings.invertMouse.value) {
+                if (GameSettings.INVERT_MOUSE.value) {
                     l = -1;
                 }
-                if (this.mc.gameSettings.smoothCamera.value) {
+                if (GameSettings.SMOOTH_CAMERA.value) {
                     deltaX = this.mouseFilterXAxis.getSmoothedDelta(deltaX, 0.05F * sensitivity);
                     deltaY = this.mouseFilterYAxis.getSmoothedDelta(deltaY, 0.05F * sensitivity);
                 } else {
@@ -431,7 +434,7 @@ public class WorldRenderer {
                 this.mc.thePlayer.interpolateTurn(deltaX, deltaY * (float) l);
             }
             if (this.mc.controllerInput != null) {
-                double speed = Time.delta * 2000 * (this.mc.gameSettings.controllerSensitivity.value + 0.5f);
+                double speed = Time.delta * 2000 * (GameSettings.CONTROLLER_SENSITIVITY.value + 0.5f);
                 if (this.zooming) speed *= 0.25f;
 
                 double x = this.mc.controllerInput.joyRight.getX() * speed;
@@ -439,7 +442,7 @@ public class WorldRenderer {
 
                 this.mc.thePlayer.interpolateTurn((float) x, (float) y);
             }
-            if (!this.mc.gameSettings.showFrameTimes.value) {
+            if (!GameSettings.SHOW_FRAME_TIMES.value) {
                 // Arrow key turning
                 // !!!!! Needs to happen somewhere that isnt updated only 20 times per second
                 PlayerInput playerInput = this.mc.thePlayer.input;
@@ -447,10 +450,10 @@ public class WorldRenderer {
                 float x = 0.0f;
                 float y = 0.0f;
 
-                playerInput.pressedLookUp = this.mc.gameSettings.keyLookUp.isPressed();
-                playerInput.pressedLookDown = this.mc.gameSettings.keyLookDown.isPressed();
-                playerInput.pressedLookLeft = this.mc.gameSettings.keyLookLeft.isPressed();
-                playerInput.pressedLookRight = this.mc.gameSettings.keyLookRight.isPressed();
+                playerInput.pressedLookUp = GameSettings.KEY_LOOK_UP.isPressed();
+                playerInput.pressedLookDown = GameSettings.KEY_LOOK_DOWN.isPressed();
+                playerInput.pressedLookLeft = GameSettings.KEY_LOOK_LEFT.isPressed();
+                playerInput.pressedLookRight = GameSettings.KEY_LOOK_RIGHT.isPressed();
 
                 if (playerInput.pressedLookUp) y++;
                 if (playerInput.pressedLookDown) y--;
@@ -458,7 +461,7 @@ public class WorldRenderer {
                 if (playerInput.pressedLookLeft) x--;
                 if (playerInput.pressedLookRight) x++;
 
-                float sensitivity = (float) (Time.delta * 1000 * (this.mc.gameSettings.mouseSensitivity.value + 0.5f));
+                float sensitivity = (float) (Time.delta * 1000 * (GameSettings.MOUSE_SENSITIVITY.value + 0.5f));
                 if (this.mc.thePlayer.isSneaking()) sensitivity *= 0.5f;
                 if (this.zooming) sensitivity *= 0.25f;
 
@@ -476,25 +479,25 @@ public class WorldRenderer {
         int mouseX = (Mouse.getX() * width) / this.mc.resolution.getWidthScreenCoords();
         int mouseY = height - (Mouse.getY() * height) / this.mc.resolution.getHeightScreenCoords() - 1;
         int c = 200;
-        if (this.mc.gameSettings.enableVsync.value) // VSync
+        if (GameSettings.ENABLE_VSYNC.value) // VSync
         {
 //        	c = mc.gameWindow.getFrequency(); // Cap fps when minimized
             c = 999;
         } else {
-            c = this.mc.gameSettings.customFpsLimit.value;
+            c = GameSettings.CUSTOM_FPS_LIMIT.value;
         }
         if (c <= 0) c = 1;
         GL41.glViewport(0, 0, this.mc.gameWindow.getWidthPixels(), this.mc.gameWindow.getHeightPixels());
         if (this.mc.currentWorld != null) {
             Debug.change("world");
-            if (!this.mc.gameSettings.enableVsync.value && this.mc.gameSettings.customFpsLimit.value == 0) // Max FPS
+            if (!GameSettings.ENABLE_VSYNC.value && GameSettings.CUSTOM_FPS_LIMIT.value == 0) // Max FPS
             {
                 renderWorld(partialTick, 0);
             } else {
                 renderWorld(partialTick, this.systemTime + (nsPerSecond / c));
             }
             Debug.change("misc");
-            if (this.mc.gameSettings.enableVsync.value || this.mc.gameSettings.customFpsLimit.value > 0) // Power saver
+            if (GameSettings.ENABLE_VSYNC.value || GameSettings.CUSTOM_FPS_LIMIT.value > 0) // Power saver
             {
                 Debug.change("sleep");
                 long timeToSleep = ((this.systemTime + (nsPerSecond / c)) - System.nanoTime());
@@ -519,7 +522,7 @@ public class WorldRenderer {
             GLRenderer.viewM4f().identity();
             GLRenderer.modelM4f().identity();
             setupScaledResolution();
-            if (this.mc.gameSettings.enableVsync.value || this.mc.gameSettings.customFpsLimit.value > 0) {
+            if (GameSettings.ENABLE_VSYNC.value || GameSettings.CUSTOM_FPS_LIMIT.value > 0) {
                 Debug.change("sleep");
                 long l2 = ((this.systemTime + (1_000_000_000L / c)) - System.nanoTime()) / 1_000_000L;
                 if (l2 < 0L) {
@@ -558,7 +561,7 @@ public class WorldRenderer {
 
             if (this.mc.currentScreen != null) {
                 CursorShape newCursor = this.mc.currentScreen.getDesiredCursor();
-                if (!this.mc.gameSettings.dynamicCursor.value) {
+                if (!GameSettings.DYNAMIC_CURSOR.value) {
                     newCursor = CursorShape.ARROW;
                 }
                 if (this.mc.gameWindow.getCursorShape() != newCursor) {
@@ -609,7 +612,7 @@ public class WorldRenderer {
         getViewMatrix(GLRenderer.viewM4f(), pt);
         CameraFrustum.recalcFrustrum();
         Debug.change("sky");
-        if ((this.mc.gameSettings.renderDistance.value > 4) && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
+        if ((GameSettings.RENDER_DISTANCE.value > 4) && !(this.mc.currentScreen instanceof ScreenModelViewer)) {
             renderGlobal.renderSky(partialTicks);
         }
 
@@ -619,13 +622,13 @@ public class WorldRenderer {
         this.mc.renderGlobal.cull(this.mc.activeCamera.getFrustum(), partialTicks);
 
         Debug.change("aurora");
-        if (this.mc.gameSettings.aurora.value && WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType()).hasAurora()) {
+        if (GameSettings.AURORA.value && WorldTypeFXDispatcher.getInstance().getDispatch(this.mc.currentWorld.getWorldType()).hasAurora()) {
             renderGlobal.renderAurora(this.mc.activeCamera, partialTicks);
         }
         Debug.change("update");
 
         int loops = 1;
-        if (this.mc.gameSettings.keyLoadChunksQuickly.isPressed()) {
+        if (GameSettings.KEY_LOAD_CHUNKS_QUICKLY.isPressed()) {
             loops = 40;
         }
         for (int i = 0; i < loops; i++) {
@@ -682,10 +685,10 @@ public class WorldRenderer {
         }
 
         Debug.change("debugoverlays");
-        if (this.mc.gameSettings.showCollisionBoxes.value) {
+        if (GameSettings.SHOW_COLLISION_BOXES.value) {
             renderGlobal.drawDebugEntityOutlines(this.mc.activeCamera, partialTicks);
         }
-        if (this.mc.gameSettings.showChunkBorders.value) {
+        if (GameSettings.SHOW_CHUNK_BORDERS.value) {
             renderGlobal.drawDebugChunkBorders(this.mc.activeCamera, partialTicks);
         }
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
@@ -711,7 +714,7 @@ public class WorldRenderer {
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.disableState(State.BLEND);
         renderRainSnow(partialTicks);
-        if (this.mc.gameSettings.clouds.value) {
+        if (GameSettings.CLOUDS.value) {
             Debug.change("clouds");
             this.fogManager.setupFog(FogManager.FOG_MODE_SKY, this.farPlaneDistance, partialTicks, GLRenderer.getFogState());
             renderGlobal.renderClouds(partialTicks);
@@ -726,12 +729,13 @@ public class WorldRenderer {
     }
 
     private void addRainParticles() {
+        if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
         Weather weather = this.mc.currentWorld.getCurrentWeather();
         if (!(weather instanceof IPrecipitation precipitation) || !precipitation.spawnRainParticles()) return;
 
         float f = this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower();
 
-        if (this.mc.gameSettings.fancyGraphics.value != 1) {
+        if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.REDUCED) {
             f /= 2.0F;
         }
         if (f == 0.0F) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
index ec3ceaed2..350195a42 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorWater.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.color;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.colorizer.Colorizer;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
@@ -16,7 +17,7 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getFallbackColor(int meta, int tintIndex) {
-		if(!this.mc.gameSettings.biomeWater.value || (this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
+		if(!GameSettings.BIOME_WATER.value || (this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
 			return 0xFFFFFFFF;
 		}
 		return super.getFallbackColor(meta, tintIndex);
@@ -24,7 +25,7 @@ public class BlockColorWater extends BlockColorCustom {
 	
 	@Override
 	public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
-		if(!this.mc.gameSettings.biomeWater.value || source.isRetro()) {
+		if(!GameSettings.BIOME_WATER.value || source.isRetro()) {
 			return 0xFFFFFFFF;
 		}
 		return super.getWorldColor(source, tilePos, tintIndex);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 7dc2e7fcf..7684fd75a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -568,10 +568,10 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGenericLantern<>(Blocks.LANTERN_FIREFLY_RED, loadDataModel("minecraft:block/lantern_firefly/red"), loadDataModel("minecraft:block/lantern_firefly/red_hanging")));
         addDispatch(new BlockModelGenericJar<>(Blocks.JAR_GLASS));
 
-        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_BLUE, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly")));
-        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_ORANGE, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly")));
-        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_PINK, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly")));
-        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_SILVER, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly")));
+        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_BLUE, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly_hanging")));
+        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_ORANGE, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly_hanging")));
+        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_PINK, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly_hanging")));
+        addDispatch(new BlockModelGenericLantern<>(Blocks.JAR_BUTTERFLY_SILVER, loadDataModel("minecraft:block/jar_butterfly"), loadDataModel("minecraft:block/jar_butterfly_hanging")));
         addDispatch(new BlockModelGenericPebbles<>(Blocks.OVERLAY_PEBBLES));
 
         addDispatch(new BlockModelGenericFenceThin<>(Blocks.FENCE_CHAINLINK, "minecraft:block/fence_thin/chain"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index f7a21a501..d1c569f3d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -53,10 +53,10 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
         float he = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 0, queryPos));
         if (renderBlocks.renderAllFaces || renderTop) {
             didRender = true;
-            IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
+            IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
             float rotation = (float) this.block.getLogic().getSlopeAngle(worldSource, tilePos);
             if (rotation > -999F) {
-                texture = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
+                tex = getBlockTextureFromSideAndMetadata(Side.NORTH, meta);
             } else {
                 rotation = 0.0F;
             }
@@ -64,39 +64,33 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
 
             tessellator.setLightmapCoord1i(LightmapHelper.max(light, lightUp));
-            if (texture.namespaceId.toString().contains("_flowing")) {
-                double centerU = texture.getSubIconU(0.5);
-                double centerV = texture.getSubIconV(0.5);
-                float cSin = Math.cos(rotation) / 2;
-                float sin = Math.sin(rotation) / 2;
-
-                double minU = texture.getIconUMin();
-                double maxU = texture.getIconUMax();
-                double minV = texture.getIconVMin();
-                double maxV = texture.getIconVMax();
-
-                double du = (maxU - centerU);
-                double dv = (maxV - centerV);
+            if (tex.namespaceId.toString().contains("_flowing")) {
+                float cos = Math.cos(-rotation + Math.PI_OVER_2_f);
+                float sin = Math.sin(-rotation + Math.PI_OVER_2_f);
 
                 tessellator.setNormal(0, 1, 0);
                 tessellator.addVertexWithUV(x, (float) y + h, z,
-                    Math.clamp(minU, maxU, -du * sin - dv * cSin + centerU),
-                    Math.clamp(minV, maxV, dv * sin + -du * cSin + centerV));
+                    tex.getSubIconU(((-0.25) * cos - (-0.25) * sin) + 0.5),
+                    tex.getSubIconV(((-0.25) * sin + (-0.25) * cos) + 0.5)
+                );
                 tessellator.addVertexWithUV(x, (float) y + hs, z + 1,
-                    Math.clamp(minU, maxU, du * sin - dv * cSin + centerU),
-                    Math.clamp(minV, maxV, dv * sin + du * cSin + centerV));
+                    tex.getSubIconU(((-0.25) * cos - (0.25) * sin) + 0.5),
+                    tex.getSubIconV(((-0.25) * sin + (0.25) * cos) + 0.5)
+                );
                 tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1,
-                    Math.clamp(minU, maxU, du * sin - (-dv) * cSin + centerU),
-                    Math.clamp(minV, maxV, -dv * sin + du * cSin + centerV));
+                    tex.getSubIconU(((0.25) * cos - (0.25) * sin) + 0.5),
+                    tex.getSubIconV(((0.25) * sin + (0.25) * cos) + 0.5)
+                );
                 tessellator.addVertexWithUV(x + 1, (float) y + he, z,
-                    Math.clamp(minU, maxU, -du * sin - (-dv) * cSin + centerU),
-                    Math.clamp(minV, maxV, -dv * sin + -du * cSin + centerV));
+                    tex.getSubIconU(((0.25) * cos - (-0.25) * sin) + 0.5),
+                    tex.getSubIconV(((0.25) * sin + (-0.25) * cos) + 0.5)
+                );
             } else {
                 tessellator.setNormal(0, 1, 0);
-                tessellator.addVertexWithUV(x, (float) y + h, z, texture.getIconUMin(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x, (float) y + hs, z + 1, texture.getIconUMax(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, texture.getIconUMax(), texture.getIconVMin());
-                tessellator.addVertexWithUV(x + 1, (float) y + he, z, texture.getIconUMin(), texture.getIconVMin());
+                tessellator.addVertexWithUV(x, (float) y + h, z, tex.getIconUMin(), tex.getIconVMax());
+                tessellator.addVertexWithUV(x, (float) y + hs, z + 1, tex.getIconUMax(), tex.getIconVMax());
+                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, tex.getIconUMax(), tex.getIconVMin());
+                tessellator.addVertexWithUV(x + 1, (float) y + he, z, tex.getIconUMin(), tex.getIconVMin());
             }
 
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
index 7fd6d8f60..1c8e56aa8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
@@ -49,7 +49,7 @@ public class BlockModelGlass<T extends BlockLogic> extends BlockModelTransparent
 
     @Override
     public @Nullable IconCoordinate getBlockTexture(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        if (Minecraft.getMinecraft().gameSettings.connectedGlass.value) {
+        if (GameSettings.CONNECTED_GLASS.value) {
             final boolean u;
             final boolean d;
             final boolean l;
